{-# OPTIONS -#include <locale.h> #-}
{-# LINE 1 "Locale.hsc" #-}
{-# OPTIONS -fglasgow-exts -ffi -#include <locale.h> #-}
{-# LINE 2 "Locale.hsc" #-}
module Locale(
    -- setlocale stuff
    Locale(..), 
    setLocaleAll, 
    getLocaleAll, 
    setLocale, 
    getLocale
    ) where

import Foreign
import Foreign.C
import Char
import GHC.Exts



{-# LINE 18 "Locale.hsc" #-}



{- 
LC_COLLATE
    Affects the behavior of regular expressions and the collation functions.
LC_CTYPE
    Affects the behavior of regular expressions, character classification,
    character conversion functions, and wide-character functions.
LC_MESSAGES
     Affects what strings are expected by commands and utilities as affirmative
     or negative responses.  It also affects what strings are given by commands
     and utilities as affirmative or negative responses, and the content of
     messages. 
LC_MONETARY
    Affects the behavior of functions that handle monetary values.
LC_NUMERIC
    Affects the behavior of functions that handle numeric values.
LC_TIME
    Affects the behavior of the time conversion functi
-}

data Locale = LC_CTYPE | LC_NUMERIC | LC_TIME | LC_COLLATE | LC_MONETARY | LC_MESSAGES | LC_ALL | LC_PAPER | LC_NAME | LC_ADDRESS | LC_TELEPHONE | LC_MEASUREMENT | LC_IDENTIFICATION
    deriving(Show, Enum)

decodeLocale :: Locale -> CInt 
decodeLocale LC_CTYPE = (0)
{-# LINE 45 "Locale.hsc" #-}
decodeLocale LC_NUMERIC = (1)
{-# LINE 46 "Locale.hsc" #-}
decodeLocale LC_COLLATE = (3)
{-# LINE 47 "Locale.hsc" #-}
decodeLocale LC_MONETARY = (4)
{-# LINE 48 "Locale.hsc" #-}
decodeLocale LC_TIME = (2)
{-# LINE 49 "Locale.hsc" #-}

{-# LINE 50 "Locale.hsc" #-}
decodeLocale LC_MESSAGES = (5)
{-# LINE 51 "Locale.hsc" #-}

{-# LINE 52 "Locale.hsc" #-}

{-# LINE 53 "Locale.hsc" #-}
decodeLocale LC_PAPER = (7)
{-# LINE 54 "Locale.hsc" #-}

{-# LINE 55 "Locale.hsc" #-}

{-# LINE 56 "Locale.hsc" #-}
decodeLocale LC_NAME = (8)
{-# LINE 57 "Locale.hsc" #-}

{-# LINE 58 "Locale.hsc" #-}

{-# LINE 59 "Locale.hsc" #-}
decodeLocale LC_ADDRESS = (9)
{-# LINE 60 "Locale.hsc" #-}

{-# LINE 61 "Locale.hsc" #-}

{-# LINE 62 "Locale.hsc" #-}
decodeLocale LC_TELEPHONE = (10)
{-# LINE 63 "Locale.hsc" #-}

{-# LINE 64 "Locale.hsc" #-}

{-# LINE 65 "Locale.hsc" #-}
decodeLocale LC_MEASUREMENT = (11)
{-# LINE 66 "Locale.hsc" #-}

{-# LINE 67 "Locale.hsc" #-}

{-# LINE 68 "Locale.hsc" #-}
decodeLocale LC_IDENTIFICATION = (12)
{-# LINE 69 "Locale.hsc" #-}

{-# LINE 70 "Locale.hsc" #-}
decodeLocale _ = -1

dString :: IO (Ptr CChar) -> IO (Maybe String)
dString action = do 
    v <- action
    if v == nullPtr then return Nothing else fmap Just (peekCString v)

setLocaleAll :: String -> IO (Maybe String)
setLocaleAll s =  dString $ withCString s (setlocale (6))
{-# LINE 79 "Locale.hsc" #-}

getLocaleAll :: IO (Maybe String)
getLocaleAll = getLocale LC_ALL

setLocale :: Locale -> String -> IO (Maybe String)
setLocale l s = case decodeLocale l of
    -1 -> return Nothing
    nl -> dString $ withCString s (setlocale nl)

getLocale :: Locale -> IO (Maybe String)
getLocale l = case decodeLocale l of 
    -1 -> return Nothing
    nl -> dString $ setlocale nl nullPtr 

foreign import ccall unsafe "locale.h setlocale" setlocale :: CInt -> Ptr CChar -> IO (Ptr CChar)


